GNU bug report logs - #46958
28.0.50; invalid-function error for macros that have function bindings

Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.

Package: emacs; Severity: minor; Reported by: Robert Irelan <rirelan@HIDDEN>; Keywords: wontfix; Done: Lars Ingebrigtsen <larsi@HIDDEN>; Maintainer for emacs is bug-gnu-emacs@HIDDEN.
bug closed, send any further explanations to 46958 <at> debbugs.gnu.org and Robert Irelan <rirelan@HIDDEN> Request was from Lars Ingebrigtsen <larsi@HIDDEN> to control <at> debbugs.gnu.org. Full text available.
Added tag(s) wontfix. Request was from Lars Ingebrigtsen <larsi@HIDDEN> to control <at> debbugs.gnu.org. Full text available.

Message received at 46958 <at> debbugs.gnu.org:


Received: (at 46958) by debbugs.gnu.org; 20 Jun 2022 01:11:05 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Jun 19 21:11:05 2022
Received: from localhost ([127.0.0.1]:53549 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1o35wX-0003nN-5G
	for submit <at> debbugs.gnu.org; Sun, 19 Jun 2022 21:11:05 -0400
Received: from quimby.gnus.org ([95.216.78.240]:56424)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <larsi@HIDDEN>) id 1o35wV-0003mr-Bu
 for 46958 <at> debbugs.gnu.org; Sun, 19 Jun 2022 21:11:03 -0400
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; d=gnus.org;
 s=20200322; h=Content-Type:MIME-Version:Message-ID:In-Reply-To:Date:
 References:Subject:Cc:To:From:Sender:Reply-To:Content-Transfer-Encoding:
 Content-ID:Content-Description:Resent-Date:Resent-From:Resent-Sender:
 Resent-To:Resent-Cc:Resent-Message-ID:List-Id:List-Help:List-Unsubscribe:
 List-Subscribe:List-Post:List-Owner:List-Archive;
 bh=KTMkekpgykStfSfnZqHguA23rZhdV1JKW+9MO/5wiAA=; b=h5skS2rBa39e4iqxgwqW7LDsN2
 CsA9RwBd+oEVdPwwNuyzay1EXv4aSO30tIMqEsbUdnSN6MqasWgHV+1hpKaCXiI10KDAcJRTzxolu
 n51XqUuFmNpU/TWRi1Ad3ypUS9rr7GT1Q8s/sbX+SHNzzB4yk4Bi9pFJU1gZSm5y+z1w=;
Received: from [84.212.220.105] (helo=xo)
 by quimby.gnus.org with esmtpsa (TLS1.3:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.92) (envelope-from <larsi@HIDDEN>)
 id 1o35wL-0004Ql-RH; Mon, 20 Jun 2022 03:10:56 +0200
From: Lars Ingebrigtsen <larsi@HIDDEN>
To: Robert Irelan <rirelan@HIDDEN>
Subject: Re: bug#46958: 28.0.50; invalid-function error for macros that have
 function bindings
References: <CAJUyYjoqYf5NM_UcEZetJLYUcUfDPsU=KZaS3sbhTLbU8VfSUQ@HIDDEN>
 <87pn0co316.fsf@HIDDEN> <87h7louzqp.fsf@HIDDEN>
 <CAJUyYjo7qezLkp=4RrVpgjuCHZ=abWt+1tdbVSfToccnY+iFbw@HIDDEN>
 <2f63faf5-656a-e9cd-2249-0576da0b9e0c@HIDDEN>
 <CAJUyYjq4ooSBrY1rT=VUXkHsCqSa-piaM=UQz1rJpUj+OpeTaw@HIDDEN>
 <2406e008-05f0-f95f-cc95-72f873bc12b8@HIDDEN>
 <CAJUyYjo4DF-toBadm-745b660hMSJTsSsjkbn4F-js6Xb24GNw@HIDDEN>
Date: Mon, 20 Jun 2022 03:10:53 +0200
In-Reply-To: <CAJUyYjo4DF-toBadm-745b660hMSJTsSsjkbn4F-js6Xb24GNw@HIDDEN>
 (Robert Irelan's message of "Sun, 7 Mar 2021 23:18:15 -0800")
Message-ID: <87mte8qgv6.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/29.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Report: Spam detection software, running on the system "quimby.gnus.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 @@CONTACT_ADDRESS@@ for details.
 Content preview:  Robert Irelan <rirelan@HIDDEN> writes: > Therefore, it
 looks like this is not a new bug in Emacs. It would be > nice if, when an
 invalid-function is thrown from bytecode, to check > the runtime environment
 to see a macro with the same name [...] 
 Content analysis details:   (-2.9 points, 5.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -1.0 ALL_TRUSTED            Passed through trusted hosts only via SMTP
 -1.9 BAYES_00               BODY: Bayes spam probability is 0 to 1%
 [score: 0.0000]
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 46958
Cc: Phil Sainty <psainty@HIDDEN>,
 "Basil L. Contovounesios" <contovob@HIDDEN>, 46958 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

Robert Irelan <rirelan@HIDDEN> writes:

> Therefore, it looks like this is not a new bug in Emacs. It would be
> nice if, when an invalid-function is thrown from bytecode, to check
> the runtime environment to see a macro with the same name is defined,
> and print a more informative error pointing out an issue with the
> compilation.

(I'm going through old bug reports that unfortunately weren't resolved
at the time.)

I'm not sure there's much to be done here on the Emacs side.  When you
compiled the file, you should have gotten a byte compilation warning
about the macro not being defined.  The runtime error (about funcalling
the macro) could be expanded, of course, to something like "invalid
function (probably a missing byte compilation `require')" or something,
but I don't think that'd add a lot of value -- since you only get into
this situation by ignoring the byte compiler warning in the first case.

So I'm closing this bug report.

-- 
(domestic pets only, the antidote for overdose, milk.)
   bloggy blog: http://lars.ingebrigtsen.no




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#46958; Package emacs. Full text available.

Message received at 46958 <at> debbugs.gnu.org:


Received: (at 46958) by debbugs.gnu.org; 8 Mar 2021 09:06:38 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Mar 08 04:06:38 2021
Received: from localhost ([127.0.0.1]:42113 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lJBqY-0001N6-2B
	for submit <at> debbugs.gnu.org; Mon, 08 Mar 2021 04:06:38 -0500
Received: from smtp-4.orcon.net.nz ([60.234.4.59]:36633)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <psainty@HIDDEN>) id 1lJBqU-0001Mw-Dg
 for 46958 <at> debbugs.gnu.org; Mon, 08 Mar 2021 04:06:36 -0500
Received: from [101.53.216.162] (port=10767 helo=[192.168.20.103])
 by smtp-4.orcon.net.nz with esmtpa (Exim 4.90_1)
 (envelope-from <psainty@HIDDEN>)
 id 1lJBqR-0007CN-T5; Mon, 08 Mar 2021 22:06:32 +1300
Subject: Re: bug#46958: 28.0.50; invalid-function error for macros that have
 function bindings
To: Robert Irelan <rirelan@HIDDEN>
References: <CAJUyYjoqYf5NM_UcEZetJLYUcUfDPsU=KZaS3sbhTLbU8VfSUQ@HIDDEN>
 <87pn0co316.fsf@HIDDEN> <87h7louzqp.fsf@HIDDEN>
 <CAJUyYjo7qezLkp=4RrVpgjuCHZ=abWt+1tdbVSfToccnY+iFbw@HIDDEN>
 <2f63faf5-656a-e9cd-2249-0576da0b9e0c@HIDDEN>
 <CAJUyYjq4ooSBrY1rT=VUXkHsCqSa-piaM=UQz1rJpUj+OpeTaw@HIDDEN>
 <2406e008-05f0-f95f-cc95-72f873bc12b8@HIDDEN>
 <CAJUyYjo4DF-toBadm-745b660hMSJTsSsjkbn4F-js6Xb24GNw@HIDDEN>
From: Phil Sainty <psainty@HIDDEN>
Message-ID: <fc8c525b-5b80-413c-72d2-16524f256bc8@HIDDEN>
Date: Mon, 8 Mar 2021 22:06:31 +1300
User-Agent: Mozilla/5.0 (X11; Linux x86_64; rv:68.0) Gecko/20100101
 Thunderbird/68.10.0
MIME-Version: 1.0
In-Reply-To: <CAJUyYjo4DF-toBadm-745b660hMSJTsSsjkbn4F-js6Xb24GNw@HIDDEN>
Content-Type: text/plain; charset=utf-8
Content-Language: en-GB
Content-Transfer-Encoding: 7bit
X-GeoIP: NZ
X-Spam_score: -2.9
X-Spam_score_int: -28
X-Spam_bar: --
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 46958
Cc: "Basil L. Contovounesios" <contovob@HIDDEN>,
 Lars Ingebrigtsen <larsi@HIDDEN>, 46958 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

On 8/03/21 8:18 pm, Robert Irelan wrote:
> I extracted the macros into a separate library `org-fc-macs` and then
> called `(require 'org-fc-macs)` from the file where the error is
> occurring `org-fc-type-normal.el`. This seems to have fixed the issue.

Good to hear.

I'll just add that my suggestion wasn't quite optimal -- as this is
a macros-only library, a better way to require it is:

(eval-when-compile (require 'org-fc-macs))

This ensures that macros are loaded for byte-compilation, but means
that subsequently loading the byte-compiled .elc library does *not*
load org-fc-macs (which is not needed in this scenario as, in the
byte-compiled code, the macro calls have already been expanded).


-Phil




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#46958; Package emacs. Full text available.

Message received at 46958 <at> debbugs.gnu.org:


Received: (at 46958) by debbugs.gnu.org; 8 Mar 2021 07:18:53 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Mar 08 02:18:53 2021
Received: from localhost ([127.0.0.1]:41949 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lJAAH-00079v-40
	for submit <at> debbugs.gnu.org; Mon, 08 Mar 2021 02:18:53 -0500
Received: from mail-wr1-f54.google.com ([209.85.221.54]:33075)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <rirelan@HIDDEN>) id 1lJAAC-00079c-Iv
 for 46958 <at> debbugs.gnu.org; Mon, 08 Mar 2021 02:18:51 -0500
Received: by mail-wr1-f54.google.com with SMTP id 7so10310198wrz.0
 for <46958 <at> debbugs.gnu.org>; Sun, 07 Mar 2021 23:18:48 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=mime-version:references:in-reply-to:from:date:message-id:subject:to
 :cc; bh=B01XU7xFmQx+Kr+VMtveCB8azL4AZ9VXLvYUqUmHZHo=;
 b=GeGi67dZsXc6aiV/OL61uNUUENaaya2UexS4ckA9VcgEt3rrR6dWnLdztAsZ4EW3HG
 Vv7x1hq/NlDZiR4sYWbCxoU5gIEUGCgP48GG7zN/IvJPxgXQT14bPATM6UCchCAPOArZ
 x0e8RikQx1Tu3zUpGKR1O+bsyPZke+m1A8usgbG0nQfO1SK3s/YnVAo8uGFf4TnjHsna
 d+SgPY9C1gOVXNOU6gpU1rDwPhCkmvorsPhUR7Q18krV64wccwgwwK7+xKFZYyr+wfhM
 JQWJW4zhbg8+sBN/AqxQ0DvmrU+39ixLKcJPXB1+v+55vVPJd4brifs+epcrBy+EYBCF
 Qlkg==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:mime-version:references:in-reply-to:from:date
 :message-id:subject:to:cc;
 bh=B01XU7xFmQx+Kr+VMtveCB8azL4AZ9VXLvYUqUmHZHo=;
 b=Kf+2cmfvlv2fc8WdJnlaznw8OFunO0dJXoVpDkYUAfo+E9bEK7GtPqR24cinbHGtUZ
 3ylo4EWPYmNo9H+f6KlZU6UvTQlHSDxEF9kQ+FAbWrJHa4E6f+OSqdz9b7vG1YOXQ0pQ
 NSENX3eSEPPUbclUJDoPXtvny7KvPxxbCmOmb/vT0shuiqvFnw4LNRUBfcXYpDMyTXHP
 YUEf1JeQBJwjHla33C6t0FQ5Ql2Z7EWSvCOMBlQD91F7wzK6FBn4HbRNbz/Il3F3R7j8
 kaW262yaQbSFg+YHnGWhmILWZyYnkW8y09Xz/mPkLPEqaS6i8iApQW7v6KoLMvP5zTIV
 swSQ==
X-Gm-Message-State: AOAM531lSgxK8BUdQyVEQuH5YvvAgTQ7AVgWu/tBNj3v3qOrCzBG88kr
 1N8PCzhizw1RYYwnAHZrReB3xJCBmXlDVW5FcA==
X-Google-Smtp-Source: ABdhPJz9tqKD7OFqPWTpt21kR7nyoPASLDhsrvLMTC1kudOAFPGZ6/3nWr0Y4UWIEzj9KxO/cO2RI8950bvbJcL9a3I=
X-Received: by 2002:adf:ed87:: with SMTP id c7mr21454148wro.9.1615187922445;
 Sun, 07 Mar 2021 23:18:42 -0800 (PST)
MIME-Version: 1.0
References: <CAJUyYjoqYf5NM_UcEZetJLYUcUfDPsU=KZaS3sbhTLbU8VfSUQ@HIDDEN>
 <87pn0co316.fsf@HIDDEN> <87h7louzqp.fsf@HIDDEN>
 <CAJUyYjo7qezLkp=4RrVpgjuCHZ=abWt+1tdbVSfToccnY+iFbw@HIDDEN>
 <2f63faf5-656a-e9cd-2249-0576da0b9e0c@HIDDEN>
 <CAJUyYjq4ooSBrY1rT=VUXkHsCqSa-piaM=UQz1rJpUj+OpeTaw@HIDDEN>
 <2406e008-05f0-f95f-cc95-72f873bc12b8@HIDDEN>
In-Reply-To: <2406e008-05f0-f95f-cc95-72f873bc12b8@HIDDEN>
From: Robert Irelan <rirelan@HIDDEN>
Date: Sun, 7 Mar 2021 23:18:15 -0800
Message-ID: <CAJUyYjo4DF-toBadm-745b660hMSJTsSsjkbn4F-js6Xb24GNw@HIDDEN>
Subject: Re: bug#46958: 28.0.50; invalid-function error for macros that have
 function bindings
To: Phil Sainty <psainty@HIDDEN>
Content-Type: text/plain; charset="UTF-8"
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 46958
Cc: "Basil L. Contovounesios" <contovob@HIDDEN>,
 Lars Ingebrigtsen <larsi@HIDDEN>, 46958 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

I extracted the macros into a separate library `org-fc-macs` and then
called `(require 'org-fc-macs)` from the file where the error is
occurring `org-fc-type-normal.el`. This seems to have fixed the issue.

Now that I see that this has resolved the issue, I believe I can
understand why. It looks the byte compiler can deal well if it is
compiling a file where a function isn't defined by any of the
`require` calls in the file - as long as the function is defined at
runtime (which it would be with the way `org-fc` is written), you
won't run into any issues. On the other hand, the byte compiler needs
to have the definitions of all macros at hand during compile time, or
else it won't be able to expand them correctly:
https://www.gnu.org/software/emacs/manual/html_node/elisp/Compiling-Macros.html.

In my case I'm using Doom Emacs, which uses the Straight package
manager. Straight has switched to byte compiling each package (along
with its explicit dependencies) in a separate process recently. When
this happened, `org-fc-type-normal.el` could no longer see the macro
definitions from `org-fc.el` at compile time, even though it could see
them at run time. Here's an explanation from the Doom Emacs package
maintainer: https://github.com/hlissner/doom-emacs/issues/4539#issuecomment-766307714.

Therefore, it looks like this is not a new bug in Emacs. It would be
nice if, when an invalid-function is thrown from bytecode, to check
the runtime environment to see a macro with the same name is defined,
and print a more informative error pointing out an issue with the
compilation.

On Sun, Mar 7, 2021 at 10:30 PM Phil Sainty <psainty@HIDDEN> wrote:
>
> On 8/03/21 10:38 am, Robert Irelan wrote:
> > No, that results in a circular import.
>
> I think a traditional way of dealing with this is to move the
> macro definitions to a separate library (e.g. fc-macs.el) and
> each library which uses the macros can then (require 'fc-macs)
>


-- 
Robert Irelan
rirelan@HIDDEN




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#46958; Package emacs. Full text available.

Message received at 46958 <at> debbugs.gnu.org:


Received: (at 46958) by debbugs.gnu.org; 8 Mar 2021 06:30:42 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Mar 08 01:30:42 2021
Received: from localhost ([127.0.0.1]:41910 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lJ9Pe-0005zC-AR
	for submit <at> debbugs.gnu.org; Mon, 08 Mar 2021 01:30:42 -0500
Received: from smtp-1.orcon.net.nz ([60.234.4.34]:34115)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <psainty@HIDDEN>) id 1lJ9Pb-0005z0-SU
 for 46958 <at> debbugs.gnu.org; Mon, 08 Mar 2021 01:30:41 -0500
Received: from [101.53.216.162] (port=51889 helo=[192.168.20.103])
 by smtp-1.orcon.net.nz with esmtpa (Exim 4.90_1)
 (envelope-from <psainty@HIDDEN>)
 id 1lJ9PY-0008Ht-Pz; Mon, 08 Mar 2021 19:30:36 +1300
Subject: Re: bug#46958: 28.0.50; invalid-function error for macros that have
 function bindings
To: Robert Irelan <rirelan@HIDDEN>
References: <CAJUyYjoqYf5NM_UcEZetJLYUcUfDPsU=KZaS3sbhTLbU8VfSUQ@HIDDEN>
 <87pn0co316.fsf@HIDDEN> <87h7louzqp.fsf@HIDDEN>
 <CAJUyYjo7qezLkp=4RrVpgjuCHZ=abWt+1tdbVSfToccnY+iFbw@HIDDEN>
 <2f63faf5-656a-e9cd-2249-0576da0b9e0c@HIDDEN>
 <CAJUyYjq4ooSBrY1rT=VUXkHsCqSa-piaM=UQz1rJpUj+OpeTaw@HIDDEN>
From: Phil Sainty <psainty@HIDDEN>
Message-ID: <2406e008-05f0-f95f-cc95-72f873bc12b8@HIDDEN>
Date: Mon, 8 Mar 2021 19:30:35 +1300
User-Agent: Mozilla/5.0 (X11; Linux x86_64; rv:68.0) Gecko/20100101
 Thunderbird/68.10.0
MIME-Version: 1.0
In-Reply-To: <CAJUyYjq4ooSBrY1rT=VUXkHsCqSa-piaM=UQz1rJpUj+OpeTaw@HIDDEN>
Content-Type: text/plain; charset=utf-8
Content-Language: en-GB
Content-Transfer-Encoding: 7bit
X-GeoIP: NZ
X-Spam_score: -2.9
X-Spam_score_int: -28
X-Spam_bar: --
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 46958
Cc: "Basil L. Contovounesios" <contovob@HIDDEN>,
 Lars Ingebrigtsen <larsi@HIDDEN>, 46958 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

On 8/03/21 10:38 am, Robert Irelan wrote:
> No, that results in a circular import.

I think a traditional way of dealing with this is to move the
macro definitions to a separate library (e.g. fc-macs.el) and
each library which uses the macros can then (require 'fc-macs)





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#46958; Package emacs. Full text available.

Message received at 46958 <at> debbugs.gnu.org:


Received: (at 46958) by debbugs.gnu.org; 7 Mar 2021 21:39:28 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Mar 07 16:39:28 2021
Received: from localhost ([127.0.0.1]:41675 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lJ17X-0001M4-O3
	for submit <at> debbugs.gnu.org; Sun, 07 Mar 2021 16:39:27 -0500
Received: from mail-wr1-f53.google.com ([209.85.221.53]:33870)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <rirelan@HIDDEN>) id 1lJ17V-0001Lo-PN
 for 46958 <at> debbugs.gnu.org; Sun, 07 Mar 2021 16:39:26 -0500
Received: by mail-wr1-f53.google.com with SMTP id u16so9366135wrt.1
 for <46958 <at> debbugs.gnu.org>; Sun, 07 Mar 2021 13:39:25 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=mime-version:references:in-reply-to:from:date:message-id:subject:to
 :cc; bh=cyK17heCuFsW+Odmk4s4UIyb0aHzaktCL9V/Oa6QSeo=;
 b=EsPe3yfHytcTYfjIUbSgvc/VQ1PnEz1pmnw+BJcIM1K/wjKuDyTNHrBsz0K6FbPtPD
 Yj+KrGiOjLpPeS9hWqsziJxcoXe41r/gje5peDsLGlIyjx+ArJYEUQl2PSNtbQa/rmMC
 ujyG2MVgFafMQwfe6qgx7bNdET9+sASFDC+3RktP7Jyw/XjUX8ER0hnb6XNBane48myZ
 WHbBhFNAzQheONQ9P3L6pSMKgt9Ft0OOVf0+daCeO4qwlWNsMRNLJ9qsUvFp+YfYBV8p
 QVPkaF3f/dV8jbMc9xaW5T6HXsQkJVTBeGxJuSPFTk97aQbkd+mmztM3ajEUrQeV/gkr
 xYcQ==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:mime-version:references:in-reply-to:from:date
 :message-id:subject:to:cc;
 bh=cyK17heCuFsW+Odmk4s4UIyb0aHzaktCL9V/Oa6QSeo=;
 b=bH6TSGNUZ6GJHymtKl+Bty4oSpGdasj7tS/dFESpWZ6Dd2JpSLqV2lFxaIttKZFVxo
 uXXUvrOLmHgytMS7SfcQf5nyHCCN6kMRVs72qGm4Lcor2n9qZojNyYdFGgH2Qbw6K1N1
 d4+8J4mN89/7TnwAFnhr9lS6vZv8HH1aaS65cNSJH5rPqFgV9nGxgy3fkt8xLy0gJfD+
 eZqYKpy1TcHo9grg9MuPhYDxgvqVs6BUW0I6BbkhKTRj8XP1Sla0Z/UxDXhPcnpsgSx8
 kLPRlfcrJfvOgBHxv4C2o9GY0fMdw9s9jq5viSyTIl0u+RJ9U6q14VVwwwhbyVIu5pcI
 SIBA==
X-Gm-Message-State: AOAM533PRti9Wn3VPlxSFPfGRgx5iowsPPU+lY1sROR6TZj8mX7IDDTM
 w86KfoMJxFI/Qki1+A61GZ0DAUmWqS8ksM+SUQ==
X-Google-Smtp-Source: ABdhPJz5QBXTI1PfhiQCkt7B8tjmCc6vV5GNaBof7unO/Seu5cV7WVRxuPxabIDlorjRsgCxVgNSDQ7gzpDVs9OiwuQ=
X-Received: by 2002:a5d:4e52:: with SMTP id r18mr20914121wrt.28.1615153159736; 
 Sun, 07 Mar 2021 13:39:19 -0800 (PST)
MIME-Version: 1.0
References: <CAJUyYjoqYf5NM_UcEZetJLYUcUfDPsU=KZaS3sbhTLbU8VfSUQ@HIDDEN>
 <87pn0co316.fsf@HIDDEN> <87h7louzqp.fsf@HIDDEN>
 <CAJUyYjo7qezLkp=4RrVpgjuCHZ=abWt+1tdbVSfToccnY+iFbw@HIDDEN>
 <2f63faf5-656a-e9cd-2249-0576da0b9e0c@HIDDEN>
In-Reply-To: <2f63faf5-656a-e9cd-2249-0576da0b9e0c@HIDDEN>
From: Robert Irelan <rirelan@HIDDEN>
Date: Sun, 7 Mar 2021 13:38:53 -0800
Message-ID: <CAJUyYjq4ooSBrY1rT=VUXkHsCqSa-piaM=UQz1rJpUj+OpeTaw@HIDDEN>
Subject: Re: bug#46958: 28.0.50; invalid-function error for macros that have
 function bindings
To: Phil Sainty <psainty@HIDDEN>
Content-Type: text/plain; charset="UTF-8"
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 46958
Cc: "Basil L. Contovounesios" <contovob@HIDDEN>,
 Lars Ingebrigtsen <larsi@HIDDEN>, 46958 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

No, that results in a circular import.

The way this file (not my code, by the way) seems to work is that it
started out as one file, org-fc.el, that contained everything. At
various points, they decided to break out some parts of the file into
separate files like this:

```
;;; org-fc.el

;; ... some definitions, including macro
`org-fc-with-point-at-back-heading' and the other `org-fc' symbols
mentioned in org-fc-type-normal.el

(require 'org-fc-type-normal)

;; ... some more definitions

(provide 'org-fc)
```

```
;;; org-fc-type-normal.el

(defun org-fc-type-normal-init ()
  "Mark headline as card of the normal type."
  (interactive)
  (org-fc--init-card "normal")
  (org-fc-review-data-update '("front")))

(defun org-fc-type-normal-setup (_position)
  "Prepare a normal card for review."
  (interactive)
  ;; Make sure the card is collapsed
  (outline-hide-subtree)
  (when (org-fc-has-back-heading-p)
    (org-show-entry)
    ;; Make sure the back heading is visible
    (org-fc-with-point-at-back-heading
     (org-show-set-visibility 'minimal))))

(defun org-fc-type-normal-flip ()
  "Flip a normal card."
  (interactive)
  (org-show-entry)
  (org-show-children)
  ;; NOTE: the body only runs if the card has a back heading
  (org-fc-with-point-at-back-heading
   (org-show-entry)
   (org-show-children)
   (org-fc-show-latex)))

(org-fc-register-type
 'normal
 'org-fc-type-normal-setup
 'org-fc-type-normal-flip
 'org-fc-noop)

;;; Footer

(provide 'org-fc-type-normal)
```

Note that `org-fc-type-normal.el` doesn't `require` anything from
`org-fc`, but assumes that they have been already defined by the time
`org-fc.el` runs the `require` call.

On Sat, Mar 6, 2021 at 2:39 PM Phil Sainty <psainty@HIDDEN> wrote:
>
> On 7/03/21 7:28 am, Robert Irelan wrote:
> > The call that's actually failing is located here:
> > https://git.sr.ht/~l3kn/org-fc/tree/711511192c62f6dccc96644dcf0705fda99e753a/item/org-fc-type-normal.el#L41.
>
> It looks like org-fc-type-normal.el should (require 'org-fc)
> at the start.
>
> Does that fix the problem?
>


-- 
Robert Irelan
rirelan@HIDDEN




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#46958; Package emacs. Full text available.

Message received at 46958 <at> debbugs.gnu.org:


Received: (at 46958) by debbugs.gnu.org; 7 Mar 2021 18:07:20 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Mar 07 13:07:20 2021
Received: from localhost ([127.0.0.1]:41483 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lIxoG-0004ac-9B
	for submit <at> debbugs.gnu.org; Sun, 07 Mar 2021 13:07:20 -0500
Received: from mail-oo1-f49.google.com ([209.85.161.49]:36345)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <pipcet@HIDDEN>) id 1lIxoE-0004aP-Rq
 for 46958 <at> debbugs.gnu.org; Sun, 07 Mar 2021 13:07:19 -0500
Received: by mail-oo1-f49.google.com with SMTP id x10so1698144oor.3
 for <46958 <at> debbugs.gnu.org>; Sun, 07 Mar 2021 10:07:18 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=mime-version:references:in-reply-to:from:date:message-id:subject:to
 :cc; bh=E3M0RxugkIip3qI/ZcCEzAHRbwSJOGbNcu9A0SMeqTE=;
 b=Zyz1HqiKRElRTni995+/zfC545wSjdunXMsApN6o+6BQWgXJct7CVN2NK9Jzt4XOme
 penYyXbakYuas9Z5aU/N4OKhCAC97wQa48o+LRtyoAfMCuJFInTh+FVsKUp9IjyWvJxd
 Vbg27oDZt2Uh7p/kfsC9qe7igNQTcO5hLNaNbBxTLZhX8U0Cfkr/WfZ4/46MPHZlBBYN
 d8BXNjciTxb7A2v8uVCy647it0sk9frzPPEMYKXtgCm0qwVYsSKxRcJFo9Oj53lHU9/E
 bZh++5l4ZOp5C7JHl7sFBbYXt0bbg3c0UW+hdtw/MPeFojgxHvZkuG8Yl39Sl4HDqXX+
 NfoQ==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:mime-version:references:in-reply-to:from:date
 :message-id:subject:to:cc;
 bh=E3M0RxugkIip3qI/ZcCEzAHRbwSJOGbNcu9A0SMeqTE=;
 b=Mqjmt1hkrpiFA0IY2RmNKciH2hH3WjdcGLRitLFdZ5xTP32aeQgckToIU0rY8rwfwJ
 l+4l1F9frEnxq49L7sEkPGnFLD4M4VfTBpFwnkFaXlyNBoG2Yi+zcBQ71WZYXqWU8x6B
 7rk/ifz/qUB4PCecKX0LHADV+wawO2Nk+2QIfis971dDIyPnBs0bX/VNqvx/lJoe8yaA
 vHdGYuSKsXJEOXdekEoUGBrY7inWNwecUe2FJzDjYSRqMY7vWz3w4duKXv4t+61ZoLHf
 YAtniAgJV7lH7DySY6uKQO4UCU1xDA7Nnd/QYRN+PS9s0Ksr7g3vzrjxzlBBrrJLAHh4
 zJsA==
X-Gm-Message-State: AOAM5330nRayc1wp0Fe+X9UW6OCMe6wHS6Njl0hXO8hnnuU6sprbnUl9
 yuVP+beLKTr2o2Lka4ad4NAce1Jig4/Sv0rzjPU=
X-Google-Smtp-Source: ABdhPJxrwqpQNw1MAO2zgzzuqJH3WPKYqizC2Q3a/rk2haw30B0bbcJw4TOUvqfdDhLN2Na7UOIVVNxjds/zDdpYeJ0=
X-Received: by 2002:a4a:2a0a:: with SMTP id k10mr15988310oof.88.1615140433323; 
 Sun, 07 Mar 2021 10:07:13 -0800 (PST)
MIME-Version: 1.0
References: <CAJUyYjoqYf5NM_UcEZetJLYUcUfDPsU=KZaS3sbhTLbU8VfSUQ@HIDDEN>
 <87pn0co316.fsf@HIDDEN>
 <CAOqdjBcNCj6UhRG8R4U+ksQjYhYC4LuLxkN=Qp3-vQxKpmyEFw@HIDDEN>
 <877dmjnef9.fsf@HIDDEN>
In-Reply-To: <877dmjnef9.fsf@HIDDEN>
From: Pip Cet <pipcet@HIDDEN>
Date: Sun, 7 Mar 2021 18:06:37 +0000
Message-ID: <CAOqdjBd8_XLVbiBTnGmX-0gVK9Z60sTSY-_azwNjkcE9TADgcw@HIDDEN>
Subject: Re: bug#46958: 28.0.50; invalid-function error for macros that have
 function bindings
To: Lars Ingebrigtsen <larsi@HIDDEN>
Content-Type: text/plain; charset="UTF-8"
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 46958
Cc: Robert Irelan <rirelan@HIDDEN>, 46958 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

On Sun, Mar 7, 2021 at 3:58 PM Lars Ingebrigtsen <larsi@HIDDEN> wrote:
> Pip Cet <pipcet@HIDDEN> writes:
> > On Sat, Mar 6, 2021 at 12:56 PM Lars Ingebrigtsen <larsi@HIDDEN> wrote:
> >> The other issue is that I think there's a misunderstanding here: You can
> >> never funcall a macro.
> >
> > You shouldn't be able to, but I don't think bug#46636 has been fixed.
>
> That's not a bug about funcalling macros,

Funny, that's precisely what it sounds like to me.

> but about M-: using
> `macroexpand-all' before evaluating, isn't it?

That's where the bug is, yes, but together with the analogous byte
optimizer bug it means that all of the usual ways of evaluating
(funcall #'when t) will succeed. That means you can funcall macros, in
my book.

Pip




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#46958; Package emacs. Full text available.

Message received at 46958 <at> debbugs.gnu.org:


Received: (at 46958) by debbugs.gnu.org; 7 Mar 2021 15:59:06 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Mar 07 10:59:06 2021
Received: from localhost ([127.0.0.1]:41214 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lIvoA-0001K4-7R
	for submit <at> debbugs.gnu.org; Sun, 07 Mar 2021 10:59:06 -0500
Received: from quimby.gnus.org ([95.216.78.240]:58266)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <larsi@HIDDEN>) id 1lIvo7-0001JY-Ax
 for 46958 <at> debbugs.gnu.org; Sun, 07 Mar 2021 10:59:05 -0500
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; d=gnus.org;
 s=20200322; h=Content-Type:MIME-Version:Message-ID:In-Reply-To:Date:
 References:Subject:Cc:To:From:Sender:Reply-To:Content-Transfer-Encoding:
 Content-ID:Content-Description:Resent-Date:Resent-From:Resent-Sender:
 Resent-To:Resent-Cc:Resent-Message-ID:List-Id:List-Help:List-Unsubscribe:
 List-Subscribe:List-Post:List-Owner:List-Archive;
 bh=3e+okfG/tFRfAntoKvUq9fTJnftmJ37Qr0gEjdIQ0e4=; b=JEYZ687Vnu5Eyjl1TKNwlPYilY
 TywgNbc9q54eCKMopVnQvGxu1HgPJSH0TpYZ79vb8ET4VI5eTCGz2o5CJ4ZQ5uxUdvI3NXS/GWCqV
 OKb2x9GWeyjffKbPy+yULX9QdAtM1Sah5nR2+q3N+3lg7Gd0kDePEz1NuAjYDQfmrYRI=;
Received: from cm-84.212.220.105.getinternet.no ([84.212.220.105] helo=xo)
 by quimby.gnus.org with esmtpsa (TLS1.3:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.92) (envelope-from <larsi@HIDDEN>)
 id 1lIvnw-00076b-In; Sun, 07 Mar 2021 16:58:56 +0100
From: Lars Ingebrigtsen <larsi@HIDDEN>
To: Pip Cet <pipcet@HIDDEN>
Subject: Re: bug#46958: 28.0.50; invalid-function error for macros that have
 function bindings
References: <CAJUyYjoqYf5NM_UcEZetJLYUcUfDPsU=KZaS3sbhTLbU8VfSUQ@HIDDEN>
 <87pn0co316.fsf@HIDDEN>
 <CAOqdjBcNCj6UhRG8R4U+ksQjYhYC4LuLxkN=Qp3-vQxKpmyEFw@HIDDEN>
Face: iVBORw0KGgoAAAANSUhEUgAAADAAAAAwBAMAAAClLOS0AAAABGdBTUEAALGPC/xhBQAAACBj
 SFJNAAB6JgAAgIQAAPoAAACA6AAAdTAAAOpgAAA6mAAAF3CculE8AAAAD1BMVEXn6NJYRzsTEBSc
 bFr///+Q5a+sAAAAAWJLR0QEj2jZUQAAAAd0SU1FB+UDBw86E/phumIAAAF1SURBVDjLbZPZgYUw
 CEXjpAGBBh6xgRD6722ArL4ZflROWALXlIYhFjcmTW8r2/g+/Lmwh3BHB7kK4A45In4KuAe/AwYY
 Vs/a3EE8AtRR+yhxglYganS8gNpnAOQT5PhwMNMFUC3R0AC42rXELAOs+kw1EcACdDArzDMVEu5r
 JgDAWcMAHUBPcM+YxAwwACsh6TVAwQ4sTJWF80xlZ/v8AEStRFvApsAxJmiKN862UszNuwcqFXUu
 d4BIpZZ/z35HUDYAcgCIYfPTnuvRdoLeL7FeH97ArwEmQxCidt8HsLIPSrEpq/jLugdyY78F4bOO
 B4Chm7uRFN0gSvR95pqub2Do48KQNwC/yKeGvt7Al0EuyL8AwDWT8R9QtUvyG2i2kPo3lVRJWetq
 lydQpeQ7n/66UtGTVYbabdSaQGQFIZr4ArEm0hmDY2Xh190ukExg/hdQGBrx9w2QbJGxAt82HRH+
 I/S/zpLSu8bQqtsBHsGRx0/9ArM5c6JvYejJAAAAJXRFWHRkYXRlOmNyZWF0ZQAyMDIxLTAzLTA3
 VDE1OjU4OjE4KzAwOjAwWP6MxAAAACV0RVh0ZGF0ZTptb2RpZnkAMjAyMS0wMy0wN1QxNTo1ODox
 OCswMDowMCmjNHgAAAAASUVORK5CYII=
X-Now-Playing: Ida's _Ten Small Paces_: "Dream Date"
Date: Sun, 07 Mar 2021 16:58:50 +0100
In-Reply-To: <CAOqdjBcNCj6UhRG8R4U+ksQjYhYC4LuLxkN=Qp3-vQxKpmyEFw@HIDDEN>
 (Pip Cet's message of "Sun, 7 Mar 2021 14:33:36 +0000")
Message-ID: <877dmjnef9.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Report: Spam detection software, running on the system "quimby.gnus.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 @@CONTACT_ADDRESS@@ for details.
 Content preview:  Pip Cet <pipcet@HIDDEN> writes: > On Sat, Mar 6, 2021 at
 12:56 PM Lars Ingebrigtsen <larsi@HIDDEN> wrote: >> The other issue is
 that I think there's a misunderstanding here: You can >> never funcall a
 macro. > > You shouldn't be a [...] 
 Content analysis details:   (-2.9 points, 5.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -1.0 ALL_TRUSTED            Passed through trusted hosts only via SMTP
 -1.9 BAYES_00               BODY: Bayes spam probability is 0 to 1%
 [score: 0.0000]
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 46958
Cc: Robert Irelan <rirelan@HIDDEN>, 46958 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Pip Cet <pipcet@HIDDEN> writes:

> On Sat, Mar 6, 2021 at 12:56 PM Lars Ingebrigtsen <larsi@HIDDEN> wrote:
>> The other issue is that I think there's a misunderstanding here: You can
>> never funcall a macro.
>
> You shouldn't be able to, but I don't think bug#46636 has been fixed.

That's not a bug about funcalling macros, but about M-: using
`macroexpand-all' before evaluating, isn't it?

-- 
(domestic pets only, the antidote for overdose, milk.)
   bloggy blog: http://lars.ingebrigtsen.no




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#46958; Package emacs. Full text available.

Message received at 46958 <at> debbugs.gnu.org:


Received: (at 46958) by debbugs.gnu.org; 7 Mar 2021 14:34:21 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Mar 07 09:34:21 2021
Received: from localhost ([127.0.0.1]:39036 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lIuU8-0007DQ-TG
	for submit <at> debbugs.gnu.org; Sun, 07 Mar 2021 09:34:21 -0500
Received: from mail-ot1-f48.google.com ([209.85.210.48]:43608)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <pipcet@HIDDEN>) id 1lIuU5-0007D9-GD
 for 46958 <at> debbugs.gnu.org; Sun, 07 Mar 2021 09:34:17 -0500
Received: by mail-ot1-f48.google.com with SMTP id v12so6666963ott.10
 for <46958 <at> debbugs.gnu.org>; Sun, 07 Mar 2021 06:34:17 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=mime-version:references:in-reply-to:from:date:message-id:subject:to
 :cc; bh=d1+1ugbwcdJEsfgy2kmKQJZDLt1O1Aulj4gGSpyfBHs=;
 b=uAlaVppmvTcwW1PN055jzj/6brqxv5D2uwupCRRT/3op4k+k5nIzu6c0IOL3kjjLfk
 RIdQYBEfPUE+GzBGQqAbuynm8Sx1SewcSAnYPmrx/hhF73dyx7rWfLZO+TCVXXJM7x0u
 yUQq4N5kSOU2QQhIVTM8WLJdvkMYDxzX14HFQOH0msGDEE8BSwQNFJZPpOJRfSfSPeAt
 S9aj4ieZXYCd/biVw81YgQ0+b03Nveo0rqSkleBvDDmj17VphPvMyd5bd//eKg4d2iyO
 6tP6vp6qz74c+r/LKh1kWUO4Ytqdb0b/wTeg9xYPCYqht2BHShK3WzisnKQ+0Ee1lY5P
 6RlQ==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:mime-version:references:in-reply-to:from:date
 :message-id:subject:to:cc;
 bh=d1+1ugbwcdJEsfgy2kmKQJZDLt1O1Aulj4gGSpyfBHs=;
 b=LtW7+FvCzMkadx28kq/P/DiJlq9aEyO66LOZjKD/ScNge3AyukVFys4XUDTBpbdfPC
 x5X5CdjHszEwfB/X+4Mp55zAf72QmXKBnHMGO8Kq0uYwtOyeTkIkevby/DFcQ2fzSik3
 u3sv9+OaTxw3HOKcLul8kY7bUA09jyiZgMDj6BSKwyuhJnlxNHhC1lqf56Ccnaf2ebgZ
 +M+UyMM6azHMWoaiqNrslJbPiegfe14Ez6RI31y7zmbOOLh0waP+wa+s5FkWCFtskzrq
 inV/roV8368ResZ4oHyPoep52k2J87OAhOWl7tcplAGSHR9u8o+g+Lq7CAQ0H17XSNgI
 ahVA==
X-Gm-Message-State: AOAM531k7EByQdKwebePhKJAfPnAaJNrzxvRcslr1v7U6PPWDODnQUKP
 2H3Ovc/veEbBjHeoRO8qmtUkElHC6NxKnucqAuk=
X-Google-Smtp-Source: ABdhPJx+AIZdozak36am9/xhHiB2TmNf8nS06BS0nuGRHNm1fAOknGuX7fiLGQBCsQ0oqoEbFRlW2IRUcC0sUdN8dRA=
X-Received: by 2002:a05:6830:1011:: with SMTP id
 a17mr13930892otp.154.1615127651981; 
 Sun, 07 Mar 2021 06:34:11 -0800 (PST)
MIME-Version: 1.0
References: <CAJUyYjoqYf5NM_UcEZetJLYUcUfDPsU=KZaS3sbhTLbU8VfSUQ@HIDDEN>
 <87pn0co316.fsf@HIDDEN>
In-Reply-To: <87pn0co316.fsf@HIDDEN>
From: Pip Cet <pipcet@HIDDEN>
Date: Sun, 7 Mar 2021 14:33:36 +0000
Message-ID: <CAOqdjBcNCj6UhRG8R4U+ksQjYhYC4LuLxkN=Qp3-vQxKpmyEFw@HIDDEN>
Subject: Re: bug#46958: 28.0.50; invalid-function error for macros that have
 function bindings
To: Lars Ingebrigtsen <larsi@HIDDEN>
Content-Type: text/plain; charset="UTF-8"
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 46958
Cc: Robert Irelan <rirelan@HIDDEN>, 46958 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

On Sat, Mar 6, 2021 at 12:56 PM Lars Ingebrigtsen <larsi@HIDDEN> wrote:
> The other issue is that I think there's a misunderstanding here: You can
> never funcall a macro.

You shouldn't be able to, but I don't think bug#46636 has been fixed.

Pip




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#46958; Package emacs. Full text available.

Message received at 46958 <at> debbugs.gnu.org:


Received: (at 46958) by debbugs.gnu.org; 7 Mar 2021 14:27:32 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Mar 07 09:27:32 2021
Received: from localhost ([127.0.0.1]:39028 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lIuNY-00072q-E5
	for submit <at> debbugs.gnu.org; Sun, 07 Mar 2021 09:27:32 -0500
Received: from mail-wr1-f50.google.com ([209.85.221.50]:33574)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <contovob@HIDDEN>) id 1lIuNV-00072c-Ne
 for 46958 <at> debbugs.gnu.org; Sun, 07 Mar 2021 09:27:31 -0500
Received: by mail-wr1-f50.google.com with SMTP id 7so8663931wrz.0
 for <46958 <at> debbugs.gnu.org>; Sun, 07 Mar 2021 06:27:29 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=tcd.ie; s=google21;
 h=from:to:cc:subject:references:date:in-reply-to:message-id
 :user-agent:mime-version;
 bh=42GF2C84TLG1F6BKD9tZD43gI4f0m9jj4MgeKCVetXE=;
 b=amnVsNlSaNoDuO3c/DH5R1sTOFtLdFJWNDUW0Dpfv7E9jgIflROjB9Pyt6jRK2XuTl
 2yzw44H+CiS9ItwmA4CKtlpmxpAA6FX2Bl+bsRhoAJ6tPG1880dYo4X/140Kfhww7pKY
 enlkmTvnxOFOB2PIXphGJcRIDo9edGTHOr7Hn0Blt7YpeRwsEbfgLMl9MvDVaNJpsiFD
 cWMokvF50Jh39GlPMxzu1kgPwtglj135RO1QexDt6l9S6Wqzyv14kQg1wPwv0YRYXKba
 Va9Q9BWeVSjWqWzffMjc+6/WdpBwnEz8XtowBqFAUpiSh9MM/in3+CV88lrd0NEtlIXS
 FPvg==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:from:to:cc:subject:references:date:in-reply-to
 :message-id:user-agent:mime-version;
 bh=42GF2C84TLG1F6BKD9tZD43gI4f0m9jj4MgeKCVetXE=;
 b=lGFUylRthCGyQiwh0p71VNZ1TKZV9iSHH9Pp/hDoBav2FpQykWOcXPmG0iHcqTdXcG
 7nmCXV+gt9itXfRyWQJpN0X8ViTHeelLmBw8/uZ0TR57A28bdc2i/wkwLxNaPX/aXOu6
 0pBVIoNmfEPJgmeEOUYcz+s4d635/MDhyf/wxSIKQnaFxnim05rtuVGBycbipUmxpRnx
 LEjL9QNPQyoqEoGWH9H3gRXStkmzozAUuBem8qQIvl+qzwa4O+aVr2w4q3+BBITBDZRQ
 2hmqp2iK/X4GBNxxH8z3KOCcSxl4Swg9LX+L9EGdbMOuPsZqtYaXZEvqaQW/hj4phnGD
 zxOA==
X-Gm-Message-State: AOAM5306EjTV/8W+xgkt/wQIeyy6bJErtJZP2mARwOaBkeRso2gUO7mJ
 VZTpVfeuzaVn5TanK4PJkCWF6A==
X-Google-Smtp-Source: ABdhPJyENxiQKV2RMQ5iYV/F5eMH70glRUbi+9Npm8SQTiOH/GjqQ8+zxm9GGCy1EFgJLcEqpKHEow==
X-Received: by 2002:adf:e482:: with SMTP id i2mr18602721wrm.392.1615127243818; 
 Sun, 07 Mar 2021 06:27:23 -0800 (PST)
Received: from localhost ([51.37.13.188])
 by smtp.gmail.com with ESMTPSA id z2sm1520108wrv.47.2021.03.07.06.27.22
 (version=TLS1_3 cipher=TLS_AES_256_GCM_SHA384 bits=256/256);
 Sun, 07 Mar 2021 06:27:23 -0800 (PST)
From: "Basil L. Contovounesios" <contovob@HIDDEN>
To: Phil Sainty <psainty@HIDDEN>
Subject: Re: bug#46958: 28.0.50; invalid-function error for macros that have
 function bindings
References: <CAJUyYjoqYf5NM_UcEZetJLYUcUfDPsU=KZaS3sbhTLbU8VfSUQ@HIDDEN>
 <87pn0co316.fsf@HIDDEN> <87h7louzqp.fsf@HIDDEN>
 <CAJUyYjo7qezLkp=4RrVpgjuCHZ=abWt+1tdbVSfToccnY+iFbw@HIDDEN>
 <2f63faf5-656a-e9cd-2249-0576da0b9e0c@HIDDEN>
Date: Sun, 07 Mar 2021 14:27:21 +0000
In-Reply-To: <2f63faf5-656a-e9cd-2249-0576da0b9e0c@HIDDEN> (Phil
 Sainty's message of "Sun, 7 Mar 2021 11:39:40 +1300")
Message-ID: <874khn599y.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 46958
Cc: Lars Ingebrigtsen <larsi@HIDDEN>, Robert Irelan <rirelan@HIDDEN>,
 46958 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Phil Sainty <psainty@HIDDEN> writes:

> On 7/03/21 7:28 am, Robert Irelan wrote:
>> The call that's actually failing is located here:
>> https://git.sr.ht/~l3kn/org-fc/tree/711511192c62f6dccc96644dcf0705fda99e753a/item/org-fc-type-normal.el#L41.
>
> It looks like org-fc-type-normal.el should (require 'org-fc)
> at the start.
>
> Does that fix the problem?

If it does, does that make this a duplicate of bug#43717?

Thanks,

-- 
Basil




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#46958; Package emacs. Full text available.

Message received at 46958 <at> debbugs.gnu.org:


Received: (at 46958) by debbugs.gnu.org; 6 Mar 2021 22:39:46 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Mar 06 17:39:46 2021
Received: from localhost ([127.0.0.1]:38495 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lIfaM-0004OG-69
	for submit <at> debbugs.gnu.org; Sat, 06 Mar 2021 17:39:46 -0500
Received: from smtp-1.orcon.net.nz ([60.234.4.34]:46191)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <psainty@HIDDEN>) id 1lIfaK-0004O7-FD
 for 46958 <at> debbugs.gnu.org; Sat, 06 Mar 2021 17:39:45 -0500
Received: from [101.53.216.162] (port=42920 helo=[192.168.20.103])
 by smtp-1.orcon.net.nz with esmtpa (Exim 4.90_1)
 (envelope-from <psainty@HIDDEN>)
 id 1lIfaH-0003NM-As; Sun, 07 Mar 2021 11:39:42 +1300
Subject: Re: bug#46958: 28.0.50; invalid-function error for macros that have
 function bindings
To: Robert Irelan <rirelan@HIDDEN>
References: <CAJUyYjoqYf5NM_UcEZetJLYUcUfDPsU=KZaS3sbhTLbU8VfSUQ@HIDDEN>
 <87pn0co316.fsf@HIDDEN> <87h7louzqp.fsf@HIDDEN>
 <CAJUyYjo7qezLkp=4RrVpgjuCHZ=abWt+1tdbVSfToccnY+iFbw@HIDDEN>
From: Phil Sainty <psainty@HIDDEN>
Message-ID: <2f63faf5-656a-e9cd-2249-0576da0b9e0c@HIDDEN>
Date: Sun, 7 Mar 2021 11:39:40 +1300
User-Agent: Mozilla/5.0 (X11; Linux x86_64; rv:68.0) Gecko/20100101
 Thunderbird/68.10.0
MIME-Version: 1.0
In-Reply-To: <CAJUyYjo7qezLkp=4RrVpgjuCHZ=abWt+1tdbVSfToccnY+iFbw@HIDDEN>
Content-Type: text/plain; charset=utf-8
Content-Language: en-GB
Content-Transfer-Encoding: 7bit
X-GeoIP: NZ
X-Spam_score: -2.9
X-Spam_score_int: -28
X-Spam_bar: --
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 46958
Cc: "Basil L. Contovounesios" <contovob@HIDDEN>,
 Lars Ingebrigtsen <larsi@HIDDEN>, 46958 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

On 7/03/21 7:28 am, Robert Irelan wrote:
> The call that's actually failing is located here:
> https://git.sr.ht/~l3kn/org-fc/tree/711511192c62f6dccc96644dcf0705fda99e753a/item/org-fc-type-normal.el#L41.

It looks like org-fc-type-normal.el should (require 'org-fc)
at the start.

Does that fix the problem?





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#46958; Package emacs. Full text available.

Message received at 46958 <at> debbugs.gnu.org:


Received: (at 46958) by debbugs.gnu.org; 6 Mar 2021 18:29:05 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Mar 06 13:29:05 2021
Received: from localhost ([127.0.0.1]:38277 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lIbfk-0004as-Tn
	for submit <at> debbugs.gnu.org; Sat, 06 Mar 2021 13:29:05 -0500
Received: from mail-wr1-f47.google.com ([209.85.221.47]:42027)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <rirelan@HIDDEN>) id 1lIbfj-0004aN-9d
 for 46958 <at> debbugs.gnu.org; Sat, 06 Mar 2021 13:29:04 -0500
Received: by mail-wr1-f47.google.com with SMTP id j2so6388562wrx.9
 for <46958 <at> debbugs.gnu.org>; Sat, 06 Mar 2021 10:29:03 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=mime-version:references:in-reply-to:from:date:message-id:subject:to
 :cc; bh=jTwcRMYkZT+8NL+6A51owUYxWLJGTKOiR1HYxACHm8M=;
 b=p32ebn/fTlBWFs52FcBLhzmPqf0ORcBt/nAMuxIXlGdAmfiQPN9hXMoVFd1aP+CVQ/
 B2sdXa530eUaVqgKsmgCTsOKDlt4IBZZdI/BhDavJTez+8g8pgJ2TCNZYQ2+PTGuErdx
 jPVnNT7Ezot4Oha65rbSB2XNApVK3+ri5/z/vR6ZD8WIH9ba+DrMAsDXIqa8WZTrlRu6
 qqH+GK7JI0FecpboSyFBr7d0dpk/ypwVg0GpTS4P3hLd/vGqB6c4njThKXK6GH9YXSim
 LROMTmk0mB+YzGHA7xOVnUM/+EaXm9US3mr0mm9MOK9OSvQ+UeWM376fUGqKpqlPYwvp
 r+Ug==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:mime-version:references:in-reply-to:from:date
 :message-id:subject:to:cc;
 bh=jTwcRMYkZT+8NL+6A51owUYxWLJGTKOiR1HYxACHm8M=;
 b=DoCZ8XNsX/0EGIUHHNNfAPPQ4NEs1HEEP3l70gHfduRAPHDXoPRdjCocMhw5mXzyMJ
 WU2bvqD0DtUtT2+45MSrn88LSKsxPIh/vvhaonPQcUVTBAVbf11lOx+GhMTberGsJwnH
 InIKoc7xZFiwzIBhoOMyu/1nChk/ygXJJN6fGcr2vrTpfgEVI74LyMxEtXhh8+xG9Q3Z
 jI0qdEJu0a0+TcOG49uQxSITmOF/tOJuob9dlVRGW60q0spsDHaWQ4t4icTNuS4kDVvt
 HeH3L0VRX8BNGCN/EJUx7ONzXN/LHJBgjMhfQpXARTpgTLYLbKuGe86ERyqVlEo+A/Vj
 l6Hg==
X-Gm-Message-State: AOAM530hRfkqeqsERHtAM10v7ra069jQWZMO0UWJFikbnDzEvF+wzAx3
 1s5MEacLusz4MBXey7C62Oe82oHjQZyLSTv+EQ==
X-Google-Smtp-Source: ABdhPJySUk350miq5+BCKyH/cnERSYuv2k0QGble/fkssc5iUnUpqcJLW7HzB8DrEkfgSEOKjQ/r3YV7CZAgRJ1EIHw=
X-Received: by 2002:a5d:50c7:: with SMTP id f7mr15500693wrt.18.1615055337017; 
 Sat, 06 Mar 2021 10:28:57 -0800 (PST)
MIME-Version: 1.0
References: <CAJUyYjoqYf5NM_UcEZetJLYUcUfDPsU=KZaS3sbhTLbU8VfSUQ@HIDDEN>
 <87pn0co316.fsf@HIDDEN> <87h7louzqp.fsf@HIDDEN>
In-Reply-To: <87h7louzqp.fsf@HIDDEN>
From: Robert Irelan <rirelan@HIDDEN>
Date: Sat, 6 Mar 2021 10:28:28 -0800
Message-ID: <CAJUyYjo7qezLkp=4RrVpgjuCHZ=abWt+1tdbVSfToccnY+iFbw@HIDDEN>
Subject: Re: bug#46958: 28.0.50; invalid-function error for macros that have
 function bindings
To: "Basil L. Contovounesios" <contovob@HIDDEN>
Content-Type: text/plain; charset="UTF-8"
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 46958
Cc: Lars Ingebrigtsen <larsi@HIDDEN>, 46958 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

On Sat, Mar 6, 2021 at 6:24 AM Basil L. Contovounesios <contovob@HIDDEN> wrote:

> Just to add: macros are fboundp but not functionp, which is the property
> that funcall requires.
>
> The funcall is here:
>
>   https://git.sr.ht/~l3kn/org-fc/tree/main/item/org-fc.el#L1284
>
> Looks like something put something in org-fc-types (e.g. using
> org-fc-register-type) that shouldn't be there.
>
> So, this doesn't seem related to Emacs, unless there's been a recent
> nativecomp regression that gave rise to this?

The call that's actually failing is located here:
https://git.sr.ht/~l3kn/org-fc/tree/711511192c62f6dccc96644dcf0705fda99e753a/item/org-fc-type-normal.el#L41.
As you can see, we're not trying to funcall a macro here, but it fails
anyway. Moreover, the macro is actually defined in my environment, and
if I run the code that's failing directly in the buffer using M-:, I
get no errors, `invalid-function` or otherwise. Is there a way a macro
might be defined in my "main" environment, so to speak, but not be
defined when being called from another function? As far as I can tell,
there are no weird `letf` shenanigans going on.

-- 
Robert Irelan
rirelan@HIDDEN




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#46958; Package emacs. Full text available.

Message received at 46958 <at> debbugs.gnu.org:


Received: (at 46958) by debbugs.gnu.org; 6 Mar 2021 14:24:24 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Mar 06 09:24:24 2021
Received: from localhost ([127.0.0.1]:36313 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lIXqy-0004Wi-Al
	for submit <at> debbugs.gnu.org; Sat, 06 Mar 2021 09:24:24 -0500
Received: from mail-wr1-f44.google.com ([209.85.221.44]:41900)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <contovob@HIDDEN>) id 1lIXqw-0004WW-N9
 for 46958 <at> debbugs.gnu.org; Sat, 06 Mar 2021 09:24:23 -0500
Received: by mail-wr1-f44.google.com with SMTP id f12so5672337wrx.8
 for <46958 <at> debbugs.gnu.org>; Sat, 06 Mar 2021 06:24:22 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=tcd.ie; s=google21;
 h=from:to:cc:subject:references:date:in-reply-to:message-id
 :user-agent:mime-version;
 bh=s5TEO9avFhB87JSCw+dnZCPN/BEvt4qTnl2K1dvJ4sU=;
 b=WC6ZyB7IbrSO2qeMKre5vI8PzzWpd2r6kRgGgmxbZMrSte3O2SiMvRDNr4mrtPF/b1
 Q3XbrjCsLwNOoAggNDxTDJwqyYC5Gqehv1Ac2m4FC4toYNhA9fuK+q6xPmvm1Y2mIldC
 /Vi/joNUfnbxZRs6v5rpPiIL04AETNbHYkJld/FJfoEdExweb+S4vIPrTApATh/CVSJz
 eGas7UICJoL/fTX5Ga0ES45FRIT5rxXEplgyPHuyUv4AB0hgf3Ktm3l/hlHhR857ZHMQ
 86s3GRHnBqdsivyCoHZ0uRa708dM1IVXdlRXECin3J9jAO5r5+lr1XqmxBHd+e344EWR
 jODg==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:from:to:cc:subject:references:date:in-reply-to
 :message-id:user-agent:mime-version;
 bh=s5TEO9avFhB87JSCw+dnZCPN/BEvt4qTnl2K1dvJ4sU=;
 b=S+vfJfF+/H7IjJ1oIRl5Ir7rximcudOE7m/7atBMYHNZxswefPa9Wd2D7UuHMIYD/d
 VOOsmCI7P2AFVr1CaHis8WRrwQcPL9ltPZ5uVIi/+ZeFxbrXB5L1qem27KhnichUgCM6
 aR0jvUwk10S7vJ68K+wqmuL1YKMjDM+Z7wt2IPQBJ8CsR9udiDcmrC+5ByeSOuM+dlKU
 sBzDp55cYDuK/KHXfdTDp/iL9v6r398zoGVChFROKK/TiKqQLm8ZD1Tb5iFIWJClEeml
 fmDKXadyTJT29bNEsF7WaUbX7nYMjUwJY6EXqBGHiOigd3/1yLXLzpx/gyyyFSuoJXJ2
 9M9A==
X-Gm-Message-State: AOAM531pffzVfo0kO2eR4DCXkds/ScsSzvAKR1gCQ+Mv0fD+8oBGGa2L
 xS54uuQX6aJvl/PhoNSX++ChVQ==
X-Google-Smtp-Source: ABdhPJxjKD3M3LIHtS46CzSrbyessEbVenDWyuLuGi5O2YxAgkkwJgvI1jDsFht3Lw+rlA2zVEdtkg==
X-Received: by 2002:adf:d0c9:: with SMTP id z9mr14978857wrh.396.1615040656873; 
 Sat, 06 Mar 2021 06:24:16 -0800 (PST)
Received: from localhost ([51.37.57.126])
 by smtp.gmail.com with ESMTPSA id o188sm2446406wme.7.2021.03.06.06.24.15
 (version=TLS1_3 cipher=TLS_AES_256_GCM_SHA384 bits=256/256);
 Sat, 06 Mar 2021 06:24:16 -0800 (PST)
From: "Basil L. Contovounesios" <contovob@HIDDEN>
To: Lars Ingebrigtsen <larsi@HIDDEN>
Subject: Re: bug#46958: 28.0.50; invalid-function error for macros that have
 function bindings
References: <CAJUyYjoqYf5NM_UcEZetJLYUcUfDPsU=KZaS3sbhTLbU8VfSUQ@HIDDEN>
 <87pn0co316.fsf@HIDDEN>
Date: Sat, 06 Mar 2021 14:24:14 +0000
In-Reply-To: <87pn0co316.fsf@HIDDEN> (Lars Ingebrigtsen's message of "Sat,
 06 Mar 2021 13:55:01 +0100")
Message-ID: <87h7louzqp.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 46958
Cc: Robert Irelan <rirelan@HIDDEN>, 46958 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Lars Ingebrigtsen <larsi@HIDDEN> writes:

> Robert Irelan <rirelan@HIDDEN> writes:
>
>> Lately I have been getting errors where occasionally `invalid-function`
>> errors will be raised when calling some macros, even when those macros
>> have function bindings (checked with `fboundp`). Here is an example of a
>> stack trace I got when using the `org-fc` package:
>>
>> ```
>> Debugger entered--Lisp error: (invalid-function
>> org-fc-with-point-at-back-heading)
>>   signal(invalid-function (org-fc-with-point-at-back-heading))
>
> I'm not quite sure I understand this bug report.  First of all,
> `org-fc-with-point-at-back-heading' doesn't seem to exist in the Emacs
> tree, so is this from an external package?

Yes:

  https://sr.ht/~l3kn/org-fc/
  https://github.com/l3kn/org-fc

See also: https://todo.sr.ht/~l3kn/org-fc/23

> The other issue is that I think there's a misunderstanding here: You can
> never funcall a macro.
>
> (macrop 'when)
> => t
> (fboundp 'when)
> => t
> (funcall 'when)
> => Debugger entered--Lisp error: (invalid-function when)
>     when()
>
> Macros are foundp, but that doesn't mean you can funcall them.

Just to add: macros are fboundp but not functionp, which is the property
that funcall requires.

The funcall is here:

  https://git.sr.ht/~l3kn/org-fc/tree/main/item/org-fc.el#L1284

Looks like something put something in org-fc-types (e.g. using
org-fc-register-type) that shouldn't be there.

So, this doesn't seem related to Emacs, unless there's been a recent
nativecomp regression that gave rise to this?

HTH,

-- 
Basil




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#46958; Package emacs. Full text available.

Message received at 46958 <at> debbugs.gnu.org:


Received: (at 46958) by debbugs.gnu.org; 6 Mar 2021 12:55:21 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Mar 06 07:55:21 2021
Received: from localhost ([127.0.0.1]:36220 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lIWSn-0000C8-9e
	for submit <at> debbugs.gnu.org; Sat, 06 Mar 2021 07:55:21 -0500
Received: from quimby.gnus.org ([95.216.78.240]:46090)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <larsi@HIDDEN>) id 1lIWSl-0000Bt-7Z
 for 46958 <at> debbugs.gnu.org; Sat, 06 Mar 2021 07:55:19 -0500
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; d=gnus.org;
 s=20200322; h=Content-Type:MIME-Version:Message-ID:In-Reply-To:Date:
 References:Subject:Cc:To:From:Sender:Reply-To:Content-Transfer-Encoding:
 Content-ID:Content-Description:Resent-Date:Resent-From:Resent-Sender:
 Resent-To:Resent-Cc:Resent-Message-ID:List-Id:List-Help:List-Unsubscribe:
 List-Subscribe:List-Post:List-Owner:List-Archive;
 bh=3cFsTEItJTGfFvsY9dREFYhm8xnZnrnkrwMWGtB+8xE=; b=iZjpdwZtqELPHT/ui54KmqMhcN
 cLc4DVqhBq/0iqnjws1/bBctevLI6h5sxEXlgq5Ndlz4o505fwqTu5fpgV1veT1SNgOHg68T4oOJv
 HBB7nZ8GXAuqYR7SXul85sNc58J3RdVa3vqBYBBVruXwvItXbEvK8lAgBbC/55jRVEuI=;
Received: from cm-84.212.220.105.getinternet.no ([84.212.220.105] helo=xo)
 by quimby.gnus.org with esmtpsa (TLS1.3:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.92) (envelope-from <larsi@HIDDEN>)
 id 1lIWSU-0001aC-Px; Sat, 06 Mar 2021 13:55:13 +0100
From: Lars Ingebrigtsen <larsi@HIDDEN>
To: Robert Irelan <rirelan@HIDDEN>
Subject: Re: bug#46958: 28.0.50; invalid-function error for macros that have
 function bindings
References: <CAJUyYjoqYf5NM_UcEZetJLYUcUfDPsU=KZaS3sbhTLbU8VfSUQ@HIDDEN>
X-Now-Playing: Cabaret Voltaire's _The Drain Train_: "(Shakedown) The Whole
 Thing (Dub)"
Date: Sat, 06 Mar 2021 13:55:01 +0100
In-Reply-To: <CAJUyYjoqYf5NM_UcEZetJLYUcUfDPsU=KZaS3sbhTLbU8VfSUQ@HIDDEN>
 (Robert Irelan's message of "Fri, 5 Mar 2021 18:00:49 -0800")
Message-ID: <87pn0co316.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Report: Spam detection software, running on the system "quimby.gnus.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 @@CONTACT_ADDRESS@@ for details.
 Content preview:  Robert Irelan <rirelan@HIDDEN> writes: > Lately I have
 been getting errors where occasionally `invalid-function` > errors will be
 raised when calling some macros,
 even when those macros > have function bindings
 (checked with `fboundp`). He [...] 
 Content analysis details:   (-2.9 points, 5.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -1.0 ALL_TRUSTED            Passed through trusted hosts only via SMTP
 -1.9 BAYES_00               BODY: Bayes spam probability is 0 to 1%
 [score: 0.0000]
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 46958
Cc: 46958 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Robert Irelan <rirelan@HIDDEN> writes:

> Lately I have been getting errors where occasionally `invalid-function`
> errors will be raised when calling some macros, even when those macros
> have function bindings (checked with `fboundp`). Here is an example of a
> stack trace I got when using the `org-fc` package:
>
> ```
> Debugger entered--Lisp error: (invalid-function
> org-fc-with-point-at-back-heading)
>   signal(invalid-function (org-fc-with-point-at-back-heading))

I'm not quite sure I understand this bug report.  First of all,
`org-fc-with-point-at-back-heading' doesn't seem to exist in the Emacs
tree, so is this from an external package?

The other issue is that I think there's a misunderstanding here: You can
never funcall a macro.

(macrop 'when)
=> t
(fboundp 'when)
=> t
(funcall 'when)
=> Debugger entered--Lisp error: (invalid-function when)
    when()

Macros are foundp, but that doesn't mean you can funcall them.

-- 
(domestic pets only, the antidote for overdose, milk.)
   bloggy blog: http://lars.ingebrigtsen.no




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#46958; Package emacs. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 6 Mar 2021 03:53:16 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Mar 05 22:53:16 2021
Received: from localhost ([127.0.0.1]:35802 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1lIO0B-0005js-Tp
	for submit <at> debbugs.gnu.org; Fri, 05 Mar 2021 22:53:16 -0500
Received: from lists.gnu.org ([209.51.188.17]:44254)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <rirelan@HIDDEN>) id 1lIMFz-00035D-E3
 for submit <at> debbugs.gnu.org; Fri, 05 Mar 2021 21:01:28 -0500
Received: from eggs.gnu.org ([2001:470:142:3::10]:55010)
 by lists.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <rirelan@HIDDEN>) id 1lIMFy-0000ay-CE
 for bug-gnu-emacs@HIDDEN; Fri, 05 Mar 2021 21:01:27 -0500
Received: from mail-wr1-x42b.google.com ([2a00:1450:4864:20::42b]:44158)
 by eggs.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_128_GCM_SHA256:128)
 (Exim 4.90_1) (envelope-from <rirelan@HIDDEN>) id 1lIMFt-00083d-SI
 for bug-gnu-emacs@HIDDEN; Fri, 05 Mar 2021 21:01:26 -0500
Received: by mail-wr1-x42b.google.com with SMTP id h98so4128009wrh.11
 for <bug-gnu-emacs@HIDDEN>; Fri, 05 Mar 2021 18:01:19 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=mime-version:from:date:message-id:subject:to;
 bh=C1AwidIc+qlm7+Pr1/mA4jiP8OkmovIRZb8t0uwEZjo=;
 b=HF7g77sBWEQz1eBj9kykr15af2Ou3l6RrtaZMdt/rHYHrw8+3Y5h4FvwyNPQoPbApH
 Uq/RgrwOZPZeRcCSHp41CCiGDpg0J1x/bpXuNLoPG9Wrw3FuzR5bWMF1+DBZsVhFIMB6
 kX3yVSctjrLxhWwff3Rd6iAOQb6NLLhQz8QmNZKkSeLfLN9n5hFAc41P9eSXxkESI/Py
 FmSld4igQcgrRPORd0R2CJKYFA164Ww8KLje0DA8fJk5lKnJ2JePtChkkljdICdWj8S+
 twYvl84LcrYAdSDWcq/x/CcihDL2MdFN5356qFVld/nTfz888hYyDxmin5quMVYFOJL5
 6dYQ==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:mime-version:from:date:message-id:subject:to;
 bh=C1AwidIc+qlm7+Pr1/mA4jiP8OkmovIRZb8t0uwEZjo=;
 b=RdcApV4+e/3Qh0+kxe1EgijnwrakLKOW+DhoJzQ2EwrpfGjujOIuAlDm8zMG3irnXv
 ImJWMnv+AU7pt2n9A0eaBDzQD4fnQVMMSegLbRsSJJEyiHeajcWhdHf00tL4eTc70ccO
 +OlsZCdEXDfA6tsEpVtc8cExb2gs7uIwgxtKgsFtlrW+6VHVfUYF9IEaBXEXf72U+4TV
 Vd8aUt2S5qrZdrDZ0siSZLJ5piBhYnTVJvAVkI/cTMGmyyWtuR5ipsKw92tFymUsoNQN
 aApohx2WwKygJKdLq2LgKavOfXB8oOHoiRLaNr3ZBNuVnIF/a5ZtRpsrnEd+5gWSmac2
 zhbA==
X-Gm-Message-State: AOAM533VgQzwsJIbPNHeOAy0qHZX4G3VDPzWzHPA4+hSh3dNDM+Avypt
 scxuDw7FytOw8ZJaHDmqio6YEoS+9Az1Vu+KClQIPtCesfKK
X-Google-Smtp-Source: ABdhPJyTNdPtrK+TeIrUzK2oFvqLG3exPxBwAcrY5WApZWJqUbH4pPRrXuuOOgGm0xXymvdwJwf8ZWlRYMaDC5/XF/M=
X-Received: by 2002:a5d:56d0:: with SMTP id m16mr11750254wrw.355.1614996077616; 
 Fri, 05 Mar 2021 18:01:17 -0800 (PST)
MIME-Version: 1.0
From: Robert Irelan <rirelan@HIDDEN>
Date: Fri, 5 Mar 2021 18:00:49 -0800
Message-ID: <CAJUyYjoqYf5NM_UcEZetJLYUcUfDPsU=KZaS3sbhTLbU8VfSUQ@HIDDEN>
Subject: 28.0.50; invalid-function error for macros that have function bindings
To: bug-gnu-emacs@HIDDEN
Content-Type: text/plain; charset="UTF-8"
Received-SPF: pass client-ip=2a00:1450:4864:20::42b;
 envelope-from=rirelan@HIDDEN; helo=mail-wr1-x42b.google.com
X-Spam_score_int: -20
X-Spam_score: -2.1
X-Spam_bar: --
X-Spam_report: (-2.1 / 5.0 requ) BAYES_00=-1.9, DKIM_SIGNED=0.1,
 DKIM_VALID=-0.1, DKIM_VALID_AU=-0.1, DKIM_VALID_EF=-0.1, FREEMAIL_FROM=0.001,
 RCVD_IN_DNSWL_NONE=-0.0001, SPF_HELO_NONE=0.001,
 SPF_PASS=-0.001 autolearn=ham autolearn_force=no
X-Spam_action: no action
X-Spam-Score: -1.3 (-)
X-Debbugs-Envelope-To: submit
X-Mailman-Approved-At: Fri, 05 Mar 2021 22:53:15 -0500
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -2.3 (--)

Lately I have been getting errors where occasionally `invalid-function`
errors will be raised when calling some macros, even when those macros
have function bindings (checked with `fboundp`). Here is an example of a
stack trace I got when using the `org-fc` package:

```
Debugger entered--Lisp error: (invalid-function
org-fc-with-point-at-back-heading)
  signal(invalid-function (org-fc-with-point-at-back-heading))
  (condition-case err (if org-fc--session (let* ((card (and t
(eieio-oref org-fc--session 'current-item)))) (if card (if (string=
(plist-get card :id) (org-id-get)) (progn (let ((type (plist-get card
:type))) (funcall (org-fc-type-flip-fn type))
(org-fc-review-rate-mode))) (message "Flashcard ID mismatch"))
(message "No flashcard review is in progress")))) (error
(org-fc-review-quit) (signal (car err) (cdr err))))
  org-fc-review-flip()
  funcall-interactively(org-fc-review-flip)
  call-interactively(org-fc-review-flip nil nil)
  command-execute(org-fc-review-flip)
 ```

I am using the nativecomp variant of Emacs 28.0.50 at Git commit
80e26472206cc44837521ba594cd50e724d9af5c, compiled using the following
Macports Port (the "emacs-app-devel" Port):

https://github.com/macports/macports-ports/blob/0c3c5e770185f4c3577b94a49170a961b88d1b98/editors/emacs/Portfile#L100-L141

Configured using:
 'configure --prefix=/opt/local --disable-silent-rules --without-dbus
 --without-gconf --without-libotf --without-m17n-flt --with-gmp
 --with-gnutls --with-json --with-xml2 --with-modules --infodir
 /opt/local/share/info/emacs --with-ns --with-lcms2 --without-harfbuzz
 --without-xaw3d --with-nativecomp --with-imagemagick --with-rsvg
 'CFLAGS=-pipe -Os
 -isysroot/Applications/Xcode.app/Contents/Developer/Platforms/MacOSX.platform/Developer/SDKs/MacOSX11.1.sdk
 -arch x86_64' 'CPPFLAGS=-I/opt/local/include
 -isysroot/Applications/Xcode.app/Contents/Developer/Platforms/MacOSX.platform/Developer/SDKs/MacOSX11.1.sdk'
 'LDFLAGS=-L/opt/local/lib -Wl,-headerpad_max_install_names -Wl,-no_pie
 -Wl,-syslibroot,/Applications/Xcode.app/Contents/Developer/Platforms/MacOSX.platform/Developer/SDKs/MacOSX11.1.sdk
 -arch x86_64''

Configured features:
JPEG TIFF GIF PNG RSVG IMAGEMAGICK GLIB NOTIFY KQUEUE ACL GNUTLS LIBXML2
ZLIB TOOLKIT_SCROLL_BARS XIM NS MODULES NATIVE_COMP THREADS JSON PDUMPER
LCMS2

Important settings:
  value of $LANG: en_US.UTF-8
  value of $XMODIFIERS: @im=ibus
  locale-coding-system: utf-8

Major mode: Org

Minor modes in effect:
  diff-hl-margin-mode: t
  global-anzu-mode: t
  anzu-mode: t
  straight-use-package-mode: t
  evil-traces-mode: t
  which-key-mode: t
  better-jumper-mode: t
  better-jumper-local-mode: t
  global-company-mode: t
  company-mode: t
  ivy-rich-project-root-cache-mode: t
  ivy-rich-mode: t
  ivy-mode: t
  evil-goggles-mode: t
  evil-escape-mode: t
  evil-snipe-override-mode: t
  evil-snipe-mode: t
  evil-snipe-override-local-mode: t
  evil-snipe-local-mode: t
  whitespace-mode: t
  git-auto-commit-mode: t
  evil-org-mode: t
  savehist-mode: t
  git-gutter-mode: t
  projectile-mode: t
  flycheck-popup-tip-mode: t
  eros-mode: t
  gcmh-mode: t
  winner-mode: t
  smartparens-global-mode: t
  smartparens-mode: t
  global-flycheck-mode: t
  flycheck-mode: t
  ws-butler-global-mode: t
  ws-butler-mode: t
  editorconfig-mode: t
  recentf-mode: t
  save-place-mode: t
  global-so-long-mode: t
  envrc-mode: t
  solaire-global-mode: t
  solaire-mode: t
  doom-modeline-mode: t
  display-fill-column-indicator-mode: t
  vi-tilde-fringe-mode: t
  display-line-numbers-mode: t
  yas-minor-mode: t
  org-super-agenda-mode: t
  override-global-mode: t
  global-git-commit-mode: t
  org-roam-mode: t
  adaptive-wrap-prefix-mode: t
  auto-compile-on-load-mode: t
  auto-compile-on-save-mode: t
  persp-mode: t
  ns-auto-titlebar-mode: t
  shell-dirtrack-mode: t
  evil-mode: t
  evil-local-mode: t
  +popup-mode: t
  general-override-mode: t
  global-eldoc-mode: t
  eldoc-mode: t
  electric-indent-mode: t
  mouse-wheel-mode: t
  file-name-shadow-mode: t
  global-font-lock-mode: t
  font-lock-mode: t
  window-divider-mode: t
  auto-composition-mode: t
  auto-encryption-mode: t
  auto-compression-mode: t
  size-indication-mode: t
  column-number-mode: t
  line-number-mode: t
  global-visual-line-mode: t
  visual-line-mode: t
  transient-mark-mode: t

Load-path shadows:
/Users/rmirelan/doom.emacs.d/.local/straight/build-28.0.50/cmake-mode/cmake-mode
hides /opt/local/share/emacs/site-lisp/cmake-mode
/Users/rmirelan/doom.emacs.d/.local/straight/build-28.0.50/map/map
hides /Applications/MacPorts/Emacs.app/Contents/Resources/lisp/emacs-lisp/map
/Users/rmirelan/doom.emacs.d/.local/straight/build-28.0.50/dash-functional/dash-functional
hides /Users/rmirelan/.doom.d/emacs-google-config/third_party/elisp/dash/dash-functional
/Users/rmirelan/doom.emacs.d/.local/straight/build-28.0.50/dash/dash
hides /Users/rmirelan/.doom.d/emacs-google-config/third_party/elisp/dash/dash
/Users/rmirelan/doom.emacs.d/.local/straight/build-28.0.50/s/s hides
/Users/rmirelan/.doom.d/emacs-google-config/third_party/elisp/s/s

Features:
(shadow sort mail-extr emacsbug sendmail elisp-def ert
evil-collection-debug debug org-duration org-crypt dabbrev magit-extras
evil-markdown smartparens-markdown markdown-mode edit-indirect tabify
company-ispell company-yasnippet company-dabbrev vc-hg vc-svn
bug-reference diff-hl-margin diff-hl-dired diff-hl
evil-collection-log-view log-view evil-collection-vc-dir vc-dir ewoc
goto-addr magit-gitflow elisp-demos evil-collection-indent
hide-mode-line evil-collection-helpful helpful trace
evil-collection-edebug edebug info-look dash-functional
evil-collection-elisp-refs elisp-refs evil-anzu anzu overseer pkg-info
lisp-mnt epl tramp tramp-loaddefs trampver tramp-integration files-x
tramp-compat ls-lisp amx evil-visual-mark-mode-autoloads
hl-line+-autoloads pocket-reader-autoloads org-super-agenda-autoloads
org-randomnote-autoloads org-ql-autoloads org-journal-autoloads
org-drill-table-autoloads org-gcal-autoloads alert-autoloads
org-fc-autoloads org-clock-csv-autoloads git-auto-commit-mode-autoloads
rainbow-identifiers-autoloads vimrc-mode-autoloads rg-autoloads
auto-compile-autoloads call-log-autoloads link-hint-autoloads
drag-stuff-autoloads yaml-mode-autoloads counsel-css-autoloads
rainbow-mode-autoloads sws-mode-autoloads stylus-mode-autoloads
sass-mode-autoloads company-web-autoloads web-mode-autoloads
slim-mode-autoloads pug-mode-autoloads haml-mode-autoloads
emmet-mode-autoloads company-shell-autoloads racer-autoloads
rustic-autoloads raku-mode-autoloads py-isort-autoloads
pyimport-autoloads python-pytest-autoloads pyvenv-autoloads
pipenv-autoloads company-anaconda-autoloads anaconda-mode-autoloads
pip-requirements-autoloads ox-hugo-autoloads ox-pandoc-autoloads
ob-async-autoloads org-roam-autoloads org-re-reveal-autoloads
org-tree-slide-autoloads centered-window-autoloads
org-pomodoro-autoloads jupyter-autoloads org-download-autoloads
orgit-autoloads org-pdftools-autoloads evil-org-autoloads
org-cliplink-autoloads toc-org-autoloads ox-clip-autoloads
htmlize-autoloads avy-autoloads org-mode-autoloads
company-nixos-options-autoloads nix-mode-autoloads
evil-markdown-autoloads edit-indirect-autoloads markdown-toc-autoloads
markdown-mode-autoloads company-math-autoloads company-reftex-autoloads
company-auctex-autoloads evil-tex-autoloads latex-preview-pane-autoloads
adaptive-wrap-autoloads auctex-autoloads xref-js2-autoloads
tide-autoloads skewer-mode-autoloads nodejs-repl-autoloads
add-node-modules-path-autoloads npm-mode-autoloads
js2-refactor-autoloads typescript-mode-autoloads rjsx-mode-autoloads
js2-mode-autoloads coffee-mode-autoloads meghanada-autoloads
groovy-mode-autoloads android-mode-autoloads
flycheck-golangci-lint-autoloads company-go-autoloads
go-gen-test-autoloads go-tag-autoloads gorepl-mode-autoloads
go-mode-autoloads go-guru-autoloads go-eldoc-autoloads
buttercup-autoloads flycheck-cask-autoloads elisp-demos-autoloads
elisp-def-autoloads overseer-autoloads macrostep-autoloads
highlight-quoted-autoloads csv-mode-autoloads rtags-autoloads
company-irony-c-headers-autoloads company-irony-autoloads
flycheck-irony-autoloads irony-eldoc-autoloads irony-autoloads
glsl-mode-autoloads opencl-mode-autoloads modern-cpp-font-lock-autoloads
disaster-autoloads demangle-mode-autoloads cuda-mode-autoloads
cmake-mode-autoloads pdf-tools-autoloads makefile-executor-autoloads
github-review-autoloads magit-todos-autoloads magit-gitflow-autoloads
lsp-ivy-autoloads lsp-ui-autoloads lsp-mode-autoloads ivy-xref-autoloads
dumb-jump-autoloads eros-autoloads quickrun-autoloads
editorconfig-autoloads envrc-autoloads ns-auto-titlebar-autoloads
osx-trash-autoloads flycheck-popup-tip-autoloads flycheck-autoloads
gitignore-mode-autoloads gitconfig-mode-autoloads
git-timemachine-autoloads browse-at-remote-autoloads fd-dired-autoloads
dired-rsync-autoloads diff-hl-autoloads dired-git-info-autoloads
diredfl-autoloads doom-snippets-autoloads auto-yasnippet-autoloads
parinfer-autoloads evil-vimish-fold-autoloads vimish-fold-autoloads
yasnippet-autoloads evil-collection-autoloads evil-quick-diff-autoloads
evil-visualstar-autoloads evil-traces-autoloads
evil-textobj-anyblock-autoloads evil-surround-autoloads
evil-snipe-autoloads evil-numbers-autoloads
evil-nerd-commenter-autoloads evil-lion-autoloads
evil-indent-plus-autoloads evil-exchange-autoloads evil-escape-autoloads
evil-embrace-autoloads evil-easymotion-autoloads evil-args-autoloads
evil-autoloads persp-mode-autoloads ace-window-autoloads
vi-tilde-fringe-autoloads evil-goggles-autoloads nav-flash-autoloads
hl-todo-autoloads solaire-mode-autoloads doom-themes-autoloads
anzu-autoloads doom-modeline-autoloads wgrep-autoloads
ivy-rich-autoloads counsel-projectile-autoloads amx-autoloads
counsel-autoloads ivy-autoloads swiper-autoloads company-dict-autoloads
company-autoloads which-key-autoloads general-autoloads
projectile-autoloads ws-butler-autoloads pcre2el-autoloads
helpful-autoloads dtrt-indent-autoloads better-jumper-autoloads
restart-emacs-autoloads rainbow-delimiters-autoloads
highlight-numbers-autoloads hide-mode-line-autoloads
all-the-icons-autoloads explain-pause-mode-autoloads gcmh-autoloads
auto-minor-mode-autoloads finder-inf use-package-autoloads
bind-key-autoloads straight-autoloads evil-collection-info info straight
char-fold help-fns radix-tree cl-print backtrace evil-collection-help
help mc-hide-unmatched-lines-mode mc-mark-more mc-cycle-cursors
multiple-cursors-core cursor-sensor evil-collection-minibuffer
evil-traces evil-ex evil-collection-which-key which-key better-jumper
company-capf company evil-collection-ivy ivy-avy avy ivy-rich counsel
xdg ivy-xref evil-collection-xref xref project swiper ivy delsel
ivy-faces ivy-overlay colir evil-goggles evil-easymotion evil-escape
evil-snipe auto-minor-mode whitespace git-auto-commit-mode org-eldoc
embrace expand-region text-mode-expansions the-org-mode-expansions
er-basic-expansions expand-region-core expand-region-custom toc-org
evil-org image-file image-converter lv savehist git-gutter-fringe
fringe-helper git-gutter evil-collection-vc-git vc-git projectile
flycheck-popup-tip evil-collection-popup popup flycheck-cask
parinfer-ext parinfer evil-collection-ediff ediff mode-local parinferlib
eros highlight-quoted rainbow-delimiters highlight-numbers parent-mode
rainbow-identifiers color raku-detect face-remap editorconfig-core
editorconfig-core-handle editorconfig-fnmatch gcmh winner paren
smartparens-config smartparens-text smartparens evil-collection-flycheck
flycheck ws-butler editorconfig recentf tree-widget saveplace so-long
envrc inheritenv nav-flash pulse jka-compr doom-themes-ext-org
solaire-mode doom-one-light-theme doom-themes doom-themes-base
doom-modeline doom-modeline-segments doom-modeline-env
doom-modeline-core shrink-path all-the-icons all-the-icons-faces
data-material data-weathericons data-octicons data-fileicons
data-faicons data-alltheicons display-fill-column-indicator
vi-tilde-fringe display-line-numbers doom-snippets doom-snippets-lib
yasnippet evil-collection-elisp-mode elisp-mode dtrt-indent ol-bibtex
bibtex .emacs org-buganizer google-bugged org-p4 p4-files google-process
aio google-paths google-platform sql evil-collection-view view
google-emacs-utilities ediff-merg ediff-mult ediff-wind ediff-diff
ediff-help ediff-util ediff-init org-super-agenda ts ht inline org-habit
org-inlinetask org-roam-protocol org-protocol use-package-bind-key
bind-key org-fc org-fc-cache org-fc-dashboard org-fc-algo-sm2 cl
org-fc-type-cloze org-fc-type-text-input org-fc-type-double
org-fc-type-normal org-fc-awk org-fc-compat svg dom parse-time iso8601
org-indent org-drill persist org-agenda orgit
evil-collection-magit-todos magit-todos pcre2el rxt re-builder hl-todo
async github-review ghub-graphql treepy gsexp ghub url-http url-gw nsm
url-auth gnutls deferred a magit-autoloads magit-submodule
magit-obsolete magit-popup magit-blame magit-stash magit-reflog
magit-bisect magit-push magit-pull magit-fetch magit-clone magit-remote
magit-commit magit-sequence magit-notes magit-worktree magit-tag
magit-merge magit-branch magit-reset magit-files magit-refs magit-status
magit core-packages package browse-url url url-proxy url-privacy
url-expand url-methods url-history url-cookie url-domsuf url-util
mailcap url-handlers magit-repos magit-apply magit-wip magit-log
which-func evil-collection-imenu imenu magit-diff smerge-mode diff
evil-collection-diff-mode diff-mode git-commit evil-collection-log-edit
log-edit message rmc puny rfc822 mml mml-sec evil-collection-epa epa epg
epg-config gnus-util rmail rmail-loaddefs mm-decode mm-bodies mm-encode
mail-parse rfc2231 rfc2047 rfc2045 mm-util ietf-drums mail-prsvr
mailabbrev mail-utils gmm-utils mailheader pcvs-util add-log magit-core
magit-autorevert autorevert filenotify magit-margin magit-transient
magit-process with-editor evil-collection-term term disp-table ehelp
evil-collection-eshell em-prompt esh-mode eshell esh-cmd esh-ext esh-opt
esh-proc esh-io esh-arg esh-module esh-groups esh-util
evil-collection-dired dired dired-loaddefs server magit-mode help-mode
magit-git magit-section magit-utils crm org-roam org-roam-link
org-roam-graph xml org-roam-doctor org-roam-dailies org-roam-capture
org-roam-db emacsql-sqlite3 emacsql emacsql-compiler org-capture
org-roam-completion org-roam-buffer org-roam-faces org-roam-macs
org-roam-compat f s dash org-id org-refile smartparens-org org-yt
org-element avl-tree generator org ob ob-tangle ob-ref ob-lob ob-table
ob-exp org-macro org-footnote org-src ob-comint org-pcomplete org-list
org-faces org-entities time-date noutline outline org-version
ob-emacs-lisp ob-core ob-eval org-table ol org-keys org-compat org-macs
org-loaddefs find-func evil-collection-calendar cal-menu calendar
cal-loaddefs adaptive-wrap evil-collection-explain-pause-mode
explain-pause-mode explain-pause-top explain-pause-log-to-socket
evil-collection-profiler profiler hl-line+ hl-line evil-collection-rg rg
vc vc-dispatcher rg-info-hack rg-menu transient format-spec rg-ibuffer
rg-result wgrep-rg evil-collection-wgrep wgrep rg-history rg-header
ibuf-ext evil-collection-ibuffer ibuffer ibuffer-loaddefs
evil-collection-grep grep evil-collection-compile compile
text-property-search auto-compile packed evil-collection-custom cus-edit
cus-start cus-load wid-edit evil-collection-comint evil-collection
annalist persp-mode let-alist ns-auto-titlebar evil evil-integration
evil-maps evil-commands ffap url-parse auth-source eieio eieio-core
eieio-loaddefs password-cache json map url-vars reveal flyspell ispell
evil-jumps evil-command-window evil-types evil-search shell pcomplete
comint ansi-color evil-macros evil-repeat evil-states evil-core advice
evil-common windmove thingatpt rect evil-digraphs evil-vars ring
easy-mmode derived core-editor core-projects core-ui edmacro kmacro comp
comp-cstr warnings rx core-keybinds pp general cl-extra easymenu seq
byte-opt cl-seq use-package-core bytecomp byte-compile cconv
core-modules tex-site core core-lib cl-macs gv cl-loaddefs cl-lib subr-x
iso-transl tooltip eldoc electric uniquify ediff-hook vc-hooks
lisp-float-type mwheel term/ns-win ns-win ucs-normalize mule-util
term/common-win tool-bar dnd fontset image regexp-opt fringe
tabulated-list replace newcomment text-mode lisp-mode prog-mode register
page tab-bar menu-bar rfn-eshadow isearch timer select scroll-bar mouse
jit-lock font-lock syntax facemenu font-core term/tty-colors frame
minibuffer cl-generic cham georgian utf-8-lang misc-lang vietnamese
tibetan thai tai-viet lao korean japanese eucjp-ms cp51932 hebrew greek
romanian slovak czech european ethiopic indian cyrillic chinese
composite charscript charprop case-table epa-hook jka-cmpr-hook simple
abbrev obarray cl-preloaded nadvice button loaddefs faces cus-face pcase
macroexp files window text-properties overlay sha1 md5 base64 format env
code-pages mule custom widget hashtable-print-readable backquote threads
kqueue cocoa ns lcms2 multi-tty make-network-process nativecomp emacs)

Memory information:
((conses 16 1524294 1845224)
 (symbols 48 62411 7)
 (strings 32 243889 240300)
 (string-bytes 1 9782634)
 (vectors 16 98776)
 (vector-slots 8 2645548 1462575)
 (floats 8 1295 10854)
 (intervals 56 39395 14863)
 (buffers 984 39))


-- 
Robert Irelan
rirelan@HIDDEN




Acknowledgement sent to Robert Irelan <rirelan@HIDDEN>:
New bug report received and forwarded. Copy sent to bug-gnu-emacs@HIDDEN. Full text available.
Report forwarded to bug-gnu-emacs@HIDDEN:
bug#46958; Package emacs. Full text available.
Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.
Last modified: Mon, 20 Jun 2022 01:15:01 UTC

GNU bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997 nCipher Corporation Ltd, 1994-97 Ian Jackson.